Index: /trunk/phpgwapi/templates/default/css/azul.css
===================================================================
--- /trunk/phpgwapi/templates/default/css/azul.css	(revision 1396)
+++ /trunk/phpgwapi/templates/default/css/azul.css	(revision 1402)
@@ -251,7 +251,9 @@
 	margin-left:2px;
 	margin-right:2px;
-	font-family: Verdana, Arial, Helvetica, sans-serif;
-	font-size: 14px;
-	font-weight: bold;
+	font-size: 16px;
+	font-weight:normal;
+	font-variant:small-caps;
+	font-style:italic;
+	text-shadow:0.2em 0.2em 3px #999999;
 	color: #000066;
 	text-align: center;
Index: /trunk/expressoAdmin1_2/setup/setup.inc.php
===================================================================
--- /trunk/expressoAdmin1_2/setup/setup.inc.php	(revision 1323)
+++ /trunk/expressoAdmin1_2/setup/setup.inc.php	(revision 1402)
@@ -11,5 +11,5 @@
 
 	$setup_info['expressoAdmin1_2']['name']      	= 'expressoAdmin1_2';
-	$setup_info['expressoAdmin1_2']['title']     	= 'ExpressoAdmin 1.2';
+	$setup_info['expressoAdmin1_2']['title']     	= 'Expresso Admin';
 	/* Ao incrementar versão, não esquecer de declarar função do tables_update.inc.php*/
 	$setup_info['expressoAdmin1_2']['version']   	= '2.0.000';
Index: /trunk/expressoMail1_2/setup/phpgw_es-es.lang
===================================================================
--- /trunk/expressoMail1_2/setup/phpgw_es-es.lang	(revision 1378)
+++ /trunk/expressoMail1_2/setup/phpgw_es-es.lang	(revision 1402)
@@ -87,6 +87,6 @@
 Export	expressoMail1_2	es-es	Exportar
 Export messages	expressoMail1_2	es-es	Exportar mensajes
-ExpressoMail 1.2 Configuration	expressoMail1_2	es-es	Configuraciones del expressoMail 1.2
-expressoMail1_2	expressoMail1_2	es-es	ExpressoMail 1.2
+ExpressoMail Configuration	expressoMail1_2	es-es	Configuraciones del expressoMail
+expressoMail1_2	common	es-es	Expresso Mail
 ExpressoMail settings	admin	es-es	Configuraciones del expresso Mail 1.2
 File extension forbidden	expressoMail1_2	es-es	Extensión de archivo prohibido
Index: /trunk/expressoMail1_2/setup/phpgw_en.lang
===================================================================
--- /trunk/expressoMail1_2/setup/phpgw_en.lang	(revision 1378)
+++ /trunk/expressoMail1_2/setup/phpgw_en.lang	(revision 1402)
@@ -113,6 +113,6 @@
 Export	expressoMail1_2	en	Export
 Export messages	expressoMail1_2	en	Export messages
-ExpressoMail 1.2 Configuration	expressoMail1_2	en	ExpressoMail 1.2 Configuration
-expressoMail1_2	expressoMail1_2	en	expressoMail1_2
+ExpressoMail Configuration	expressoMail1_2	en	ExpressoMail Configuration
+expressoMail1_2	common	en	Expresso Mail
 ExpressoMail settings	admin	en	ExpressoMail settings
 File extension forbidden	expressoMail1_2	en	File extension forbidden
Index: /trunk/expressoMail1_2/setup/setup.inc.php
===================================================================
--- /trunk/expressoMail1_2/setup/setup.inc.php	(revision 1323)
+++ /trunk/expressoMail1_2/setup/setup.inc.php	(revision 1402)
@@ -11,5 +11,5 @@
 
 	$setup_info['expressoMail1_2']['name']      	= 'expressoMail1_2';
-	$setup_info['expressoMail1_2']['title']     	= 'ExpressoMail 1.2';
+	$setup_info['expressoMail1_2']['title']     	= 'Expresso Mail';
 	$setup_info['expressoMail1_2']['version']   	= '2.0.000';
 	$setup_info['expressoMail1_2']['app_order'] 	= 2;
Index: /trunk/expressoMail1_2/inc/hook_home.inc.php
===================================================================
--- /trunk/expressoMail1_2/inc/hook_home.inc.php	(revision 1265)
+++ /trunk/expressoMail1_2/inc/hook_home.inc.php	(revision 1402)
@@ -10,5 +10,5 @@
 	
 	$current_app = 'expressoMail1_2';
-	$current_name	 = 'ExpressoMail 1.2';
+	$current_name	 = 'Expresso Mail';
 	$preferences = $GLOBALS['phpgw']->preferences->read();
         $_SESSION['phpgw_info']['user']['preferences']['expressoMail'] = $preferences['expressoMail'];
Index: /trunk/expressoMail1_2/js/globals.js
===================================================================
--- /trunk/expressoMail1_2/js/globals.js	(revision 1121)
+++ /trunk/expressoMail1_2/js/globals.js	(revision 1402)
@@ -38,6 +38,5 @@
 	'<tr>'+
 	'<td style="padding-left:17px" width=33% id="content_quota" align=left></td>'+
-	'<td width=33% height=16px align=center nowrap><font face=Verdana, Arial, Helvetica, sans-serif color=#000066 size=2>'+
-	'<b class="boxHeaderText">ExpressoMail</b><font class="boxHeaderText" size=1><b> - Versão 1.2</b></font></td>'+
+	'<td class="divAppboxHeader" width=33%>Expresso Mail</td>'+
 	'<td width=33% id="div_menu_c3" align=right></td>'+
 	'</tr></table>';
Index: /trunk/expressoMail1_2/templates/default/main.css
===================================================================
--- /trunk/expressoMail1_2/templates/default/main.css	(revision 1259)
+++ /trunk/expressoMail1_2/templates/default/main.css	(revision 1402)
@@ -505,2 +505,11 @@
 }
 
+.divAppboxHeader
+{	font-style:italic;	
+	font-weight:normal;
+	font-variant: small-caps;	
+	color: #000066;
+	font-size: 16px !important;
+	text-align: center;	
+	padding: 0px;
+}