Index: /trunk/contactcenter/inc/class.bo_people_catalog.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.bo_people_catalog.inc.php	(revision 1408)
+++ /trunk/contactcenter/inc/class.bo_people_catalog.inc.php	(revision 1418)
@@ -893,5 +893,6 @@
 
 			@return integer $id The Contact ID
-		*/	
+		*/
+		//alterada para receber a informacao em 'notes' - Rommel Cysne - rommel.cysne@serpro.gov.br
 		function add_single_entry ( $data )
 		{
@@ -1052,4 +1053,6 @@
 				);
 		*/
+		//alterada para receber os outros parametros existentes na adicao completa de contatos pessoais
+		//Rommel Cysne - rommel.cysne@serpro.gov.br
 		function quick_add ( $data )
 		{
@@ -1072,9 +1075,11 @@
 			
 			$new_data = array(
-				'alias'              => $data['alias'],
-				'id_status'          => 1,
-				'given_names'        => $data['given_names'],
-				'family_names'       => $data['family_names'],
-				'names_ordered'      => $data['given_names'].' '.$data['family_names'],
+				'alias'			=> $data['alias'],
+				'id_status'		=> 1,
+				'given_names'		=> $data['given_names'],
+				'family_names'		=> $data['family_names'],
+				'names_ordered'		=> $data['given_names'].' '.$data['family_names'],
+				'birthdate'		=> $data['birthdate'],
+				'notes'			=> $data['notes'],
 			);
 
@@ -1099,5 +1104,80 @@
 			 		'connection_is_default' => 1,
 		 		);
-			}
+				$i++;
+			}
+
+			if($data['connections']['fax']['connection_value'])
+			{
+				$new_data['connections']['connection'.$i] = array(
+					'id_typeof_connection'  => $preferences['personCardPhone'],
+					'connection_name'       => $data['connections']['fax']['connection_name'],
+					'connection_value'      => $data['connections']['fax']['connection_value'],
+					'connection_is_default' => 'false',
+				);
+				$i++;
+			}
+
+			if($data['connections']['residencial_phone']['connection_value'])
+			{
+				$new_data['connections']['connection'.$i] = array(
+					'id_typeof_connection'  => $preferences['personCardPhone'],
+					'connection_name'       => $data['connections']['residencial_phone']['connection_name'],
+					'connection_value'      => $data['connections']['residencial_phone']['connection_value'],
+					'connection_is_default' => 'false',
+				);
+				$i++;
+			}
+
+			if($data['connections']['cellular_phone']['connection_value'])
+			{
+				$new_data['connections']['connection'.$i] = array(
+					'id_typeof_connection'  => $preferences['personCardPhone'],
+					'connection_name'       => $data['connections']['cellular_phone']['connection_name'],
+					'connection_value'      => $data['connections']['cellular_phone']['connection_value'],
+					'connection_is_default' => 'false',
+				);
+				$i++;
+			}
+
+			if($data['connections']['pager']['connection_value'])
+			{
+				$new_data['connections']['connection'.$i] = array(
+					'id_typeof_connection'  => $preferences['personCardPhone'],
+					'connection_name'       => $data['connections']['pager']['connection_name'],
+					'connection_value'      => $data['connections']['pager']['connection_value'],
+					'connection_is_default' => 'false',
+				);
+				$i++;
+			}
+
+			if($data['connections']['alternative_email']['connection_value'])
+			{
+				$new_data['connections']['connection'.$i] = array(
+					'id_typeof_connection'  => $preferences['personCardEmail'],
+					'connection_name'       => $data['connections']['alternative_email']['connection_name'],
+					'connection_value'      => $data['connections']['alternative_email']['connection_value'],
+					'connection_is_default' => 'false',
+				);
+				$i++;
+			}
+			$j = 1;
+
+			if($data['addresses']['addr1']['address_value'])
+			{
+				$new_data['addresses']['address'.$j] = array(
+					'id_typeof_address'	=> 1, //<id_typeof_address> - 1 - Comercial; 2 - Residencial
+					'address1'		=> $data['addresses']['addr1']['address_value'],
+					'address2'		=> $data['addresses']['addr2']['address_value'],
+					'id_country'		=> 'BR',
+					//'complement'		=> '<complement>',
+					//'address_other'	=> '<address_other>',
+					'postal_code'		=> $data['addresses']['cep']['address_value'],
+					//'po_box'		=> '<po_box>',
+					//'id_city'		=> '<city>',
+					'address_is_default'	=> 'false',
+				);
+				$j++;
+			}
+
 
 			return $this->add_single_entry($new_data);