Index: trunk/jabberit_messenger/inc/jabberit_sessions.inc.php
===================================================================
--- trunk/jabberit_messenger/inc/jabberit_sessions.inc.php	(revision 1076)
+++ trunk/jabberit_messenger/inc/jabberit_sessions.inc.php	(revision 1431)
@@ -23,14 +23,14 @@
 		
 		//Members Group
-		$_SESSION['phpgw_info']['jabberit_messenger']['membership']	= $GLOBALS['phpgw']->accounts->membership();
+		$_SESSION['phpgw_info']['jabberit_messenger']['membership']		= $GLOBALS['phpgw']->accounts->membership();
 
 		//Groups Locked
-		$_SESSION['phpgw_info']['jabberit_messenger']['groups_locked'] = $GLOBALS['phpgw_info']['server']['groups_locked_jabberit'];
+		$_SESSION['phpgw_info']['jabberit_messenger']['groups_locked']	= $GLOBALS['phpgw_info']['server']['groups_locked_jabberit'];
 
 		//Server http or https 
-		$_SESSION['phpgw_info']['jabberit_messenger']['use_https'] 	= $GLOBALS['phpgw_info']['server']['use_https'];
+		$_SESSION['phpgw_info']['jabberit_messenger']['use_https']		= $GLOBALS['phpgw_info']['server']['use_https'];
 
 		//Organization Ldap
-		$_SESSION['phpgw_info']['jabberit_messenger']['account_dn']	= $GLOBALS['phpgw_info']['user']['account_dn'];
+		$_SESSION['phpgw_info']['jabberit_messenger']['account_dn']		= $GLOBALS['phpgw_info']['user']['account_dn'];
 
 		//Ldap
@@ -49,14 +49,14 @@
 
 		//Jabberd
-        $_SESSION['phpgw_info']['jabberit_messenger']['name_jabberit']			= $GLOBALS['phpgw_info']['server']['name_jabberit'];
-        $_SESSION['phpgw_info']['jabberit_messenger']['port_jabberit']			= $GLOBALS['phpgw_info']['server']['port_jabberit'];
-        $_SESSION['phpgw_info']['jabberit_messenger']['resource_jabberit']		= $GLOBALS['phpgw_info']['server']['resource_jabberit'];
-        $_SESSION['phpgw_info']['jabberit_messenger']['group_chat_jabberit']	= $GLOBALS['phpgw_info']['server']['group_chat_server_jabberit'];
-		$_SESSION['phpgw_info']['jabberit_messenger']['use_ssl_jabberit']		= $GLOBALS['phpgw_info']['server']['use_ssl_jabberit'];
-		$_SESSION['phpgw_info']['jabberit_messenger']['use_proxy_java']			= $GLOBALS['phpgw_info']['server']['use_proxy_java'];
-		$_SESSION['phpgw_info']['jabberit_messenger']['name_company']			= $GLOBALS['phpgw_info']['server']['name_company_applet_jabberit'];
-		$_SESSION['phpgw_info']['jabberit_messenger']['use_attribute_jabberit'] = $GLOBALS['phpgw_info']['server']['use_attribute_jabberit'];
-		$_SESSION['phpgw_info']['jabberit_messenger']['attributes_org_ldap_jabberit']		= $GLOBALS['phpgw_info']['server']['attributes_org_ldap_jabberit'];
-		$_SESSION['phpgw_info']['jabberit_messenger']['map_org_realm_jabberit']				= $GLOBALS['phpgw_info']['server']['map_org_realm_jabberit'];
+        $_SESSION['phpgw_info']['jabberit_messenger']['name_jabberit']					= $GLOBALS['phpgw_info']['server']['name_jabberit'];
+        $_SESSION['phpgw_info']['jabberit_messenger']['ip_server_jabberit']				= $GLOBALS['phpgw_info']['server']['ip_server_jabberit'];
+        $_SESSION['phpgw_info']['jabberit_messenger']['port_1_jabberit']				= $GLOBALS['phpgw_info']['server']['port_1_jabberit'];
+        $_SESSION['phpgw_info']['jabberit_messenger']['port_2_jabberit']				= $GLOBALS['phpgw_info']['server']['port_2_jabberit'];        
+        $_SESSION['phpgw_info']['jabberit_messenger']['resource_jabberit']				= $GLOBALS['phpgw_info']['server']['resource_jabberit'];
+        $_SESSION['phpgw_info']['jabberit_messenger']['group_chat_jabberit']			= $GLOBALS['phpgw_info']['server']['group_chat_server_jabberit'];
+		$_SESSION['phpgw_info']['jabberit_messenger']['name_company']					= $GLOBALS['phpgw_info']['server']['name_company_applet_jabberit'];
+		$_SESSION['phpgw_info']['jabberit_messenger']['use_attribute_jabberit']			= $GLOBALS['phpgw_info']['server']['use_attribute_jabberit'];
+		$_SESSION['phpgw_info']['jabberit_messenger']['attributes_org_ldap_jabberit']	= $GLOBALS['phpgw_info']['server']['attributes_org_ldap_jabberit'];
+		$_SESSION['phpgw_info']['jabberit_messenger']['map_org_realm_jabberit']			= $GLOBALS['phpgw_info']['server']['map_org_realm_jabberit'];
 
 ?>